library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity Counter is
    Port ( clk_in, en_in : in  STD_LOGIC;
           o, result : out STD_LOGIC_VECTOR(3 downto 0) :="0000";
			  tc : out STD_LOGIC := '0';
           reset : in  STD_LOGIC := '0';
			  done : out STD_LOGIC);
end Counter;

architecture Behavioral of Counter is
	signal counter: unsigned(3 downto 0) :="0000";
	signal cnt_clk, clk_i, en: STD_LOGIC;
	
	component selectable_clock is
	Port ( clk : in std_logic;
	       s0 : in std_logic;
	       s1 : in std_logic;
	       out_clk : out std_logic);
	end component;
	
	component debounce is 
	Port ( input : in std_logic;
		clk : in std_logic;
		output : out std_logic);
	end component;
begin
	
	done <= not en_in;
	
	clk_div : selectable_clock
	port map(
		clk => clk_in,
		s0 => '1',
		s1 => '1',
		out_clk => clk_i);
		
	deb : debounce
	port map(
		input => reset,
		clk => clk_in,
		output => en);

--	cnt_clk <= clk_i and en;
	
	o <= std_logic_vector(counter);
	result <= std_logic_vector(counter);
	
	process(clk_i)
	begin
		if rising_edge(clk_i) then
			if reset = '1' then
				counter <= "0000";
			elsif en_in = '1' and counter <= "1111" then
				counter <= counter + "0001";
			end if;
		end if;
	end process;
	
	process(counter)
	begin
		if counter = "1111" then
			tc <= '1';
		else
			tc <= '0';
		end if;
	end process;
end Behavioral;

