LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
ENTITY test_counter IS
END test_counter;
 
ARCHITECTURE behavior OF test_counter IS 
 
    COMPONENT Counter
    PORT(
         clk_in : IN  std_logic;
         en_in : IN  std_logic;
         o : OUT  std_logic_vector(3 downto 0);
         result : OUT  std_logic_vector(3 downto 0);
         tc : OUT  std_logic;
         reset : IN  std_logic;
         done : OUT  std_logic
        );
    END COMPONENT;

   signal clk_in : std_logic := '0';
   signal en_in : std_logic := '0';
   signal reset : std_logic := '0';

   signal o : std_logic_vector(3 downto 0);
   signal result : std_logic_vector(3 downto 0);
   signal tc : std_logic;
   signal done : std_logic;

   constant clk_in_period : time := 10 ns;
 
BEGIN
   uut: Counter PORT MAP (
          clk_in => clk_in,
          en_in => en_in,
          o => o,
          result => result,
          tc => tc,
          reset => reset,
          done => done
        );

   -- Clock process definitions
   clk_in_process :process
   begin
		clk_in <= '0';
		wait for clk_in_period/2;
		clk_in <= '1';
		wait for clk_in_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin
      wait for 100 ns;
		
		reset <= '1';
		wait for clk_in_period;
		reset <= '0';
		wait for clk_in_period*3;
		en_in <= '1';
		wait for clk_in_period*9;
		en_in <= '0';
      

      wait;
   end process;

END;
